//***************************************************************
// Modulname:    $Source: $
// User:         $Author: $
// Version:      $Name: $  $Revision: $
// Datum:        $Date: $
// Qualitt:     $State: $
//***************************************************************
// Beschreibung:
//***************************************************************
// Historie:
//==========
// $Log: $
//***************************************************************
// Steuerparameter:
//***************************************************************
#pragma MAXARGS(10)
//***************************************************************
// globale Definitionen
//***************************************************************
#define SM_PRINTF_C
//****************************************************************
// verwendete Include Dateien
//****************************************************************


#include <lcd_def.h>

// enthaelt allgemeine Einstellungen zum Projekt
#include <asci_hex.h>
#include <itoa.h>
#include <stdarg.h>
//#include <stdio.h>
#include <sm_printf.h>

//***************************************************************
// Definitionen von Funktionen
//***************************************************************

//***************************************************************
// Funktionsname v_SM_Printf() 
// Version: 1.0    Datum 
// bergabeparameter: keine
// Beschreibung: 
// Test der sm_printf-Routine
//***************************************************************
void v_SM_Printf(char *pcPtr,...){
  va_list vaSpeicher;
  unsigned char aucBuffer[17], ucOffset;

// 1. Anlegen des vaiablen Speichers
  va_start(vaSpeicher, pcPtr);
// 2. Abbruchbedingung auf 0 pruefen.
  while (*pcPtr) {
// 2.1 Ueberpruefung ob ein Zeichen ausgegeben werden soll
    if (*pcPtr != '%')
      putchar(*pcPtr);
// 2.2 Ein Parameter soll ausgegeben werden
    else {
// 2.21 Auswahl des Parameters
      switch(*(++pcPtr)){
        case 'b': v_Itoa(va_arg(vaSpeicher,int), 2, aucBuffer);
                  ucOffset = 0;
                  while (aucBuffer[ucOffset]) {
                    putchar(aucBuffer[ucOffset]); ucOffset++;
                  }; break;
        case 'c': putchar(va_arg(vaSpeicher,char)); break;
        case 'd': v_Itoa(va_arg(vaSpeicher,int), 10, aucBuffer); 
                  ucOffset = 0;
                  while (aucBuffer[ucOffset]) {
                    putchar(aucBuffer[ucOffset]); ucOffset++;
                  }; break;
         
        default: putchar(*pcPtr);
     }
    }
// 3. Pointer auf naechtes Element setzen
    pcPtr++;
  }
}
